/*	
 *	clipldir.c
 *
 *	ؑցE16K\
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Sun Jun 6 14:11:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 *	* Mon Jun 7 09:00:00 JST 2004 Naoyuki Sawa
 *	- X^oCɑΉ܂B
 *	* Tue Jun 8 19:00:00 JST 2004 Naoyuki Sawa
 *	- 4bit`̂߂̃JX^pceLCDDrawObject()̃W[Ɋ܂߂܂B
 *	* Wed Jun 9 20:45:00 JST 2004 Naoyuki Sawa
 *	- ̂߁A16K4KϊA2sNZÂ܂Ƃ߂ď悤ɕύX܂B
 *	* Thu Jun 10 19:00:00 JST 2004 Naoyuki Sawa
 *	- new_pceLCDTrans()̏{̂RAMֈڂAldirect_mkbuf()Ƃ܂B
 */
#include "clip.h"

/****************************************************************************
 *	
 ****************************************************************************/

/*
 *	LDIRECThCo\
 */
typedef struct _LDIRECT {
	void (*old_pceLCDTrans)();			/* {pceLCDTrans()ۑBNULLȂΖłB */
	int (*old_pceLCDDrawObject)(DRAW_OBJECT obj);	/* {pceLCDDrawObjectۑB */
	int (*old_pceAppNotify)(int type, int param);	/* {pceAppNotify()ۑB   */
	//
	int multiplier;					/* 8-bit timer̊荞ݎgpłB          */
	int counter;					/* 荞ݖ+1AmultiplyɒBXVsB */
	//
	int phase;					/* ؑւ̑ԍBldirect_cvttbl[]̃RgQƁB  */
	int timer;					/* fobOpBʍXV+1܂B                */
	//
	unsigned char wbuff[DISP_X / 2 * DISP_Y];	/* pceLCDTrans()ɉʃobt@̓eRs[܂B
							 * 8sNZPʂŁAs4sNZ4bitA㑱4sNZ4bitɏd˂Ċi[܂B
							 * ŏ16sNZɂƂĎƁÂ悤ɂȂ܂B
							 *	wbuff[0] = pixel( 0,0)<<4|pixel( 4,0)
							 *	wbuff[1] = pixel( 1,0)<<4|pixel( 5,0)
							 *	wbuff[2] = pixel( 2,0)<<4|pixel( 6,0)
							 *	wbuff[3] = pixel( 3,0)<<4|pixel( 7,0)
							 *	wbuff[4] = pixel( 8,0)<<4|pixel(12,0)
							 *	wbuff[5] = pixel( 9,0)<<4|pixel(13,0)
							 *	wbuff[6] = pixel(10,0)<<4|pixel(14,0)
							 *	wbuff[7] = pixel(11,0)<<4|pixel(15,0)
							 */
} LDIRECT;
static LDIRECT _ldirect;

// * 4sNZꂽ2̃sNZ̑gA16K4Kɕϊe[ułB
//   ȉ̃vOɂĐ܂B
//
//	#define C(c) (((c) & 1) << 15 | ((c) & 2) << 6) /* C[15]=c[0], C[7]=c[1] */
//	const unsigned short ctbl[16 + (5 - 1)] = {
//		C(0),C(0),C(0),C(0),C(0), C(1),C(1),C(1),C(1),C(1), C(2),C(2),C(2),C(2),C(2), C(3),C(3),C(3),C(3),C(3)
//	/*	|<----------------------------------- phase0 ----------------------------------->|			*/
//	/*	          |<----------------------------------- phase2 ----------------------------------->|		*/
//	/*	                    |<----------------------------------- phase4 ----------------------------------->|	*/
//	/*	     |<----------------------------------- phase1 ----------------------------------->|			*/
//	/*	               |<----------------------------------- phase3 ----------------------------------->|	*/
//	};
//	#undef C
//	void make_cvttbl() {
//		int phase, pixel0, pixel4;
//		printf("static const unsigned short ldirect_cvttbl[5][256] = {\n");
//		for(phase = 0; phase < 5; phase++) {
//			for(pixel0 = 0; pixel0 < 16; pixel0++) {
//				if(pixel0 == 0) printf("{"); else printf(" ");
//				for(pixel4 = 0; pixel4 < 16; pixel4++) {
//					/* C[15]=pixel4[0],C[11]=pixel0[0],C[7]=pixel4[1],C[3]=pixel0[1] */
//					printf("0x%04x", ctbl[phase + pixel4] | ctbl[phase + pixel0] >> 4);
//					if(pixel0 == 15 && pixel4 == 15) printf("}"); printf(",");
//				}
//				if(pixel0 & 1) printf("\n");
//			}
//		}
//		printf("};\n");
//	}
//
static const unsigned short ldirect_cvttbl[5][256] = {
{0x0000,0x0000,0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080, 0x0000,0x0000,0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,
 0x0000,0x0000,0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080, 0x0000,0x0000,0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,
 0x0000,0x0000,0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080, 0x0800,0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,
 0x0800,0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880, 0x0800,0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,
 0x0800,0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880, 0x0800,0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,
 0x0008,0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088, 0x0008,0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,
 0x0008,0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088, 0x0008,0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,
 0x0008,0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088, 0x0808,0x0808,0x0808,0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888},
{0x0000,0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080, 0x0000,0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080,
 0x0000,0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080, 0x0000,0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080,
 0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880, 0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,
 0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880, 0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,
 0x0800,0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880, 0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,
 0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088, 0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,
 0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088, 0x0008,0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,
 0x0808,0x0808,0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888, 0x0808,0x0808,0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888},
{0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080,0x8080, 0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080,0x8080,
 0x0000,0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080,0x8080, 0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,
 0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880, 0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,
 0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880, 0x0800,0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,
 0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088, 0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,
 0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088, 0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,
 0x0008,0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088, 0x0808,0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,
 0x0808,0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888, 0x0808,0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888},
{0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080,0x8080,0x8080, 0x0000,0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080,0x8080,0x8080,
 0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880, 0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880,
 0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880, 0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880,
 0x0800,0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880, 0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088,
 0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088, 0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088,
 0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088, 0x0008,0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088,
 0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,0x8888, 0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,0x8888,
 0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,0x8888, 0x0808,0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,0x8888},
{0x0000,0x8000,0x8000,0x8000,0x8000,0x8000,0x0080,0x0080,0x0080,0x0080,0x0080,0x8080,0x8080,0x8080,0x8080,0x8080, 0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880,0x8880,
 0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880,0x8880, 0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880,0x8880,
 0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880,0x8880, 0x0800,0x8800,0x8800,0x8800,0x8800,0x8800,0x0880,0x0880,0x0880,0x0880,0x0880,0x8880,0x8880,0x8880,0x8880,0x8880,
 0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088,0x8088, 0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088,0x8088,
 0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088,0x8088, 0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088,0x8088,
 0x0008,0x8008,0x8008,0x8008,0x8008,0x8008,0x0088,0x0088,0x0088,0x0088,0x0088,0x8088,0x8088,0x8088,0x8088,0x8088, 0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,0x8888,0x8888,
 0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,0x8888,0x8888, 0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,0x8888,0x8888,
 0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,0x8888,0x8888, 0x0808,0x8808,0x8808,0x8808,0x8808,0x8808,0x0888,0x0888,0x0888,0x0888,0x0888,0x8888,0x8888,0x8888,0x8888,0x8888},
};

static void new_pceLCDTrans();
static int new_pceLCDDrawObject(DRAW_OBJECT obj);
static int new_pceAppNotify(int type, int param);
static void _ldirect_isr() __attribute__((unused));
       void  ldirect_isr();

/****************************************************************************
 *	O[o֐
 ****************************************************************************/

void
ldirect_init(int interval)
{
	LDIRECT* ldirect = &_ldirect;
	//
	int clock_division_ratio;
	pceAPPHEAD* pceAppHead;

	/* ܂Amɉ܂B */
	ldirect_free();

	/* hCo\̂NA܂B */
	memset(ldirect, 0, sizeof(LDIRECT));

	/* 8-bit timer̕߂܂B
	 * * vXP[fPSCIN^4096ŒƂ܂B
	 * * fPSCIN24MHz܂48MHzłB
	 *   24MHzƉ肵Đݒ肵ĂA48MHz_ldirect_isr()֐ɂĔɊԈ܂B
	 */
	//clock_division_ratio = (interval/*[ms]*/ / 1e3) / (4096 / 24e6[Hz]);
	//ό`...
	//clock_division_ratio =  interval                / (4096 / 24e3    );
	//ό`...
	clock_division_ratio = interval * 24000 / 4096;

	/* 8-bit timer̊荞ݎg܂B */
	ldirect->multiplier = 1;
	while(clock_division_ratio > 256) {
		clock_division_ratio >>= 1;
		ldirect->multiplier  <<= 1;
	}
	clock_division_ratio--; /* 8-bit timer̎dl */

	/* pceLCDTrans()tbN܂B */
	ldirect->old_pceLCDTrans = pceVectorSetKs(KSNO_LCDTrans, new_pceLCDTrans);
	/* ȍ~`܂ł̕sȏԂpceLCDTrans()ĂԂƊ댯łBDIE()Ȃ!! */

	/* pceLCDDrawObject()tbN܂B */
	ldirect->old_pceLCDDrawObject = pceVectorSetKs(KSNO_LCDDrawObject, new_pceLCDDrawObject);

	/* pceAppNotify()tbN܂B
	 * 2004/11/05ǋL
	 * * pceAppNotify()Cuɒ`̂ŁA̓Cu(clippce.c)Œ`ĂpceAppNotify()tbN邱ƂɂȂ܂B
	 *   ̃W[̎ɕῶ܂B
	 *   CuW[ŁAatnotify()gĂ͂܂!!
	 *   ݂̎łatnotify()͈xgȂ߁Aatnotify()gƃAvP[Vatnotify()gȂȂĂ܂łB
	 */
	pceAppHead = (pceAPPHEAD*)pceSystemGetInfo()->sram_top;
	ldirect->old_pceAppNotify = pceAppHead->notify_proc;
	pceAppHead->notify_proc = new_pceAppNotify;

	/*** 8-bit timer 2 ݒ  ***/

	/* ^C}~܂B */
	pT8_CTL2 = 0;

	/* vXP[~܂B */
	bCLKCTL_T8_23_P8TON2 = 0;

	/* 荞݃T[rX[`CXg[܂B */
	pceVectorSetTrap(TRAP_8TU2, ldirect_isr);

	/* 荞݃vCIeBŒ჌xɐݒ肵܂B
	 * * 荞݃vCIeB0͕KubN̂ŁA荞݃vCIeB1Œ჌xƂȂ܂B
	 * * 8-bit timer 0`3͑Sē荞݃vCIeBݒL܂B
	 *   A8-bit timer荞݂𗘗pvOƂ͋ł܂B
	 *   P/ECEJ[l(PieceSystem Ver1.20)8-bit timer荞݂𗘗pĂȂ̂ŖɂȂ܂񂪁A
	 *   AvP[VvO8-bit timer荞݂𗘗pꍇ͉炩̑΍􂪕KvƂȂ܂B
	 */
	bINT_P8T_PSIO0_P8TM = 1;

	/* Ô߁AԂ̊荞ݗvtONA܂B
	 * * 8-bit timer 0/1/3̊荞ݗvtONAĂ܂\܂B
	 *   ڂ́A_ldirect_isr()̃RgQƂĂB
	 */
	bINT_F8T_F8TU2 = 0;

	/* vXP[ݒ肵܂B */
	bCLKSEL_T8_P8TPCK2 = 0;			/* NbN */
	bCLKCTL_T8_23_P8TS2 = CLKDIV_8T2_4096;	/* fPSCIN^4096 */

	/* ^C}ݒ肵܂B */
	pT8_RLD2 = clock_division_ratio;

	/* vXP[Jn܂B */
	bCLKCTL_T8_23_P8TON2 = 1;

	/* ^C}Jn܂B */
	pT8_CTL2 = 3; /* RUN & PRESETANbNo͕͂sv */

	/* 荞݂܂B */
	bINT_E8T_E8TU2 = 1;

	/*** 8-bit timer 2 ݒ ܂ ***/
}

void
ldirect_free()
{
	LDIRECT* ldirect = &_ldirect;
	//
	pceAPPHEAD* pceAppHead;

	/* ĂȂΉ܂B */
	if(!ldirect->old_pceLCDTrans) return;

	/*** 8-bit timer 2 ݒ  ***/

	/* 荞݂֎~܂B */
	bINT_E8T_E8TU2 = 0;

	/* ^C}~܂B */
	pT8_CTL2 = 0;

	/* vXP[~܂B */
	bCLKCTL_T8_23_P8TON2 = 0;

	/*** 8-bit timer 2 ݒ ܂ ***/

	/* pceAppNotify()̃tbN܂B */
	pceAppHead = (pceAPPHEAD*)pceSystemGetInfo()->sram_top;
	pceAppHead->notify_proc = ldirect->old_pceAppNotify;

	/* pceLCDDrawObject()̃tbN܂B */
	pceVectorSetKs(KSNO_LCDDrawObject, ldirect->old_pceLCDDrawObject);

	/* pceLCDTrans()̃tbN܂B */
	pceVectorSetKs(KSNO_LCDTrans, ldirect->old_pceLCDTrans);

	/* hCo\̂NA܂B */
	memset(ldirect, 0, sizeof(LDIRECT));
}

int
ldirect_timer()
{
	return _ldirect.timer;
}

/****************************************************************************
 *	[J֐
 ****************************************************************************/

static void
new_pceLCDTrans()
{
	ldirect_mkbuf(_ldirect.wbuff, pceLCDSetBuffer(INVALIDPTR));
}

static int
new_pceAppNotify(int type, int param)
{
	LDIRECT* ldirect = &_ldirect;
	//
	int retval;

	switch(type) {
	case APPNF_SMSTART:
		/* VXej[JnɁAؑւ~܂B */
		retval = ldirect->old_pceAppNotify(type, param);
		if(retval == APPNR_ACCEPT) { /* SMSTART̍m艞ACCEPT݂̂ł */
			bINT_E8T_E8TU2 = 0; /* 8-bit timer 2 荞݋֎~ */
		}
		return retval;

	case APPNF_SMRESUME:
		/* VXej[IɁAؑւĊJ܂B */
		retval = ldirect->old_pceAppNotify(type, param);
		bINT_E8T_E8TU2 = 1; /* 8-bit timer 2 荞݋ */
		return retval;

	case APPNF_STANDBY:
		/* X^oC֎~Ƃ܂B
		 * * {́AX^oCؑւ~̂łA
		 *   pceAppNotify()ɂ̓X^oCAʒmȂ̂ŁAĊJ^C~O܂B
		 *   ނAؑ֎gp̓X^oC֎~Ƃ܂B
		 * 2004/06/07 ύX
		 * X^oCɑΉ܂B
		 * * VXeɑ΂Ă̓X^oCۂAgŃX^oC邱Ƃŉ\łB
		 */
		retval = ldirect->old_pceAppNotify(type, param);
		if(retval == APPNR_ACCEPT || retval == APPNR_IGNORE) { /* STANDBY̍m艞ACCEPTIGNOREł */
			bINT_E8T_E8TU2 = 0; /* 8-bit timer 2 荞݋֎~ */
			pcePowerEnterStandby(0);
			bINT_E8T_E8TU2 = 1; /* 8-bit timer 2 荞݋ */
		}
		return APPNR_REJECT; /* VXeɑ΂Ă̓X^oCۂƂɂ */

	case APPNF_EXITREQ:
		/* AvP[VIɁAؑւ܂B */
		retval = ldirect->old_pceAppNotify(type, param);
		if(retval == APPNR_ACCEPT || retval == APPNR_IGNORE) { /* EXITREQ̍m艞ACCEPTIGNOREł */
			ldirect_free();
		}
		return retval;
	}

	return ldirect->old_pceAppNotify(type, param);
}

/* void ldirect_isr() */
asm("
	.code
	.align 1
ldirect_isr:
	pushn %r15
	ld.w %r0, %alr
	ld.w %r1, %ahr
	pushn %r1
	call _ldirect_isr
	popn %r1
	ld.w %ahr, %r1
	ld.w %alr, %r0
	popn %r15
	reti
");

static void
_ldirect_isr()
{
	LDIRECT* ldirect = &_ldirect;
	//
	const unsigned short* cvttbl;

	/* 8-bit timer 2 荞ݗvtONA܂B
	 * * Read/Modify/Writê߁A8-bit timer 0/1/3̊荞ݗvtONAĂ܂\܂B
	 *   ̖́AP/ECEJ[lReadWrite̊荞݃NA@IĂ邱ƂɋNAs\łB
	 *   P/ECEJ[l(PieceSystem Ver1.20)8-bit timer荞݂𗘗pĂȂ̂ŖɂȂ܂񂪁A
	 *   AvP[VvO8-bit timer荞݂𗘗pꍇ͉炩̑΍􂪕KvƂȂ܂B
	 */
	bINT_F8T_F8TU2 = 0;

	/* ʃvCIeB̑d荞݂󂯕t܂B */
	ENABLE;

	/* 8-bit timer̊荞ݎg܂B */
	ldirect->counter++;
	if(bP0_P0D_P07D) { /* 24MHz */
		if(ldirect->counter < ldirect->multiplier * 1) return;
	} else {           /* 48MHz */
		if(ldirect->counter < ldirect->multiplier * 2) return;
	}
	ldirect->counter = 0;

	/* ϊe[u̐擪AhX߂܂B */
	cvttbl = &ldirect_cvttbl[ldirect->phase][0];

	/* ʓ]̃C[`Ăяo܂B */
	ldirect_trans(ldirect->wbuff, cvttbl);

	/* ̂߂ɁAtF[Yi߂܂B */
	if((ldirect->phase += 2) >= 5) ldirect->phase -= 5;

	/* fobOp^C}JEgAbv܂B */
	ldirect->timer++;
}

/****************************************************************************
 *	pceLCDDrawObject() 4bit`T|[g
 ****************************************************************************/

static int
new_pceLCDDrawObject(DRAW_OBJECT obj)
{
	PIECE_VRAM dest;
	int n;

	/* 4bit(}XNt/}XN)`̕`̂ݏ܂B
	 * ȊǑ`́A{pceLCDDrawObject()ɔC܂B
	 */
	if(obj.src->header.bpp != 4) {
		return _ldirect.old_pceLCDDrawObject(obj);
	}

	/* ]VRAM񂪐ݒ肳ĂȂ΁Alݒ肵܂B
	 * * pceLCDSetObject()gꍇ́A]VRAM񂪐ݒ肳ĂȂ̂ŁAlg܂B
	 *   render_object()gꍇ́A]VRAM񂪐ݒ肳Ă܂B
	 */
	if(obj.dest != NULL) {
		dest = *obj.dest;
	} else {
		dest.w = DISP_X;
		dest.h = DISP_Y;
		dest.buf = pceLCDSetBuffer(INVALIDPTR);
		obj.dest = &dest; /* YȂ!! */
	}

	/* ]NbsOB */
	if(!(obj.param & DRW_REVX)) {
		if(obj.dx < obj.clip.left) {
			n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
			obj.dx = obj.clip.left;
			obj.dw -= n;
			obj.sx += n;
		}
		if(obj.dx + obj.dw > obj.clip.right) {
			obj.dw = obj.clip.right - obj.dx;
		}
	} else {
		if(obj.dx < obj.clip.left) {
			n = obj.clip.left - obj.dx; /* ɂ͂ݏosNZ */
			obj.dx = obj.clip.left;
			obj.dw -= n;
		}
		if(obj.dx + obj.dw > obj.clip.right) {
			n = obj.dx + obj.dw - obj.clip.right; /* Eɂ͂ݏosNZ */
			obj.dw -= n;
			obj.sx += n;
		}
	}
	if(obj.dw <= 0) return 0; /* ʊO */
	if(!(obj.param & DRW_REVY)) {
		if(obj.dy < obj.clip.top) {
			n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
			obj.dy = obj.clip.top;
			obj.dh -= n;
			obj.sy += n;
		}
		if(obj.dy + obj.dh > obj.clip.bottom) {
			obj.dh = obj.clip.bottom - obj.dy;
		}
	} else {
		if(obj.dy < obj.clip.top) {
			n = obj.clip.top - obj.dy; /* ɂ͂ݏosNZ */
			obj.dy = obj.clip.top;
			obj.dh -= n;
		}
		if(obj.dy + obj.dh > obj.clip.bottom) {
			n = obj.dy + obj.dh - obj.clip.bottom; /* ɂ͂ݏosNZ */
			obj.dh -= n;
			obj.sy += n;
		}
	}
	if(obj.dh <= 0) return 0; /* ʊO */

	/* ]NbsO͍s܂B
	 * Xw肳ꂽ]`]rbg}bvɎ܂ĂȂ΁A
	 * ]NbsOɂē]͂ݏoƂ͂肦ȂłB
	 * {͓]NbsOsĂ̂ŁA̓_͔݊łB
	 */

	/* 4bit`惋[`̖{̂Ăяo܂B */
	PDW_Draw_4BN(obj);

	return 1; /* ȂƂꕔʓ */
}

